// OpenLievVideoDoc.h : interface of the COpenLievVideoDoc class
//
#pragma once

#include <afxmt.h>

class CVideoManager;
class COpenLiveVideoDoc : public CDocument
{
	DECLARE_DYNCREATE(COpenLiveVideoDoc)
public: // create from serialization only
	COpenLiveVideoDoc();
	virtual ~COpenLiveVideoDoc();

	void InitVideoManager();

	void StartVideoThread();
	void StopVideoThread();

	// Set Function
	void SetViewWnd(CView *wnd) { _viewWnd = wnd; }

	void RefreshToolBar();
	void RecalcLayout();

public:
	CVideoManager *_videoManager;
	CWinThread	  *_videoThread;
	CView		  *_viewWnd;

	CEvent _newImgReady, _nextFrameEnd, _killNextFrame;

public:
	virtual void Serialize(CArchive& ar);
	#ifdef _DEBUG
		virtual void AssertValid() const;
		virtual void Dump(CDumpContext& dc) const;
	#endif


protected:	// Generated message map functions
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnOpenVideoDevice(UINT nID);
	afx_msg void OnUpdateOpenVideoDevice(CCmdUI *pCmdUI);
};