#pragma once

#import "SGSVideoSource.tlb" no_namespace, named_guids

class CVideoManager
{
public:
	CVideoManager(void);
	~CVideoManager(void);

	bool InitVideoStream(SourceDlg dialog, int videoChannel);
	bool StopVideoStream();

	int NextFrame();

	bool IsVideoStraemOpen() { return _isVideoStreamOpen; }

	void PrepareVideoDeviceName();
	void PrepareVideoDeviceProperty();

	int GetMaxVChannelNumber() { return _maxVChannelNumber;  }
	int GetVideoChannelNumber(){ return _videoChannelNumber; }

	BITMAPINFO *GetColorHeader(){ return _colorHeader; }
	BITMAPINFO *GetGrayHeader() { return _grayHeader;  }
	UCHAR *GetColorData()       { return _colorImageData; }
	UCHAR *GetGrayData()        { return _grayImageData;  }
    CString GetVideoDeviceName(){ return _videoDeviceName;}
	CString GetVideoDeviceName(int index);

	CSize GetColorImageSize(){ return CSize(_colorImageSize.width, _colorImageSize.height); }
	CSize GetGrayImageSize() { return CSize(_grayImageSize.width, _grayImageSize.height);   }

private:
	IVideoModulePtr _videoModulePtr;
    IVideoDevicePropertyPtr _videoProrertyPtr;

	bool _isVideoStreamOpen;

	int _videoStatus;
	int _maxVChannelNumber;
    int _videoChannelNumber;

	VideoImageSize _colorImageSize, _lastColorImageSize;
	VideoImageSize _grayImageSize;
	BITMAPINFO *_colorHeader, *_grayHeader;
	UCHAR *_colorImageData, *_grayImageData;

	CString _videoDeviceName;
	CString _videoDeviceList[MAX_DEVICE_NUM];
};